;================================================================================
;----Avoider Decode--------------------------------------------------------------
;================================================================================


alias decode2plain {
  var %r, %l 1

  %r = $replace($1-,,B,,-,>,-,,-,,-,,E,,C,,A,,R,,K,,y,ﺘ,i,ﺉ,s,דּ,t,טּ,u,ﻉ,e,,k,,F,,u,,g,Χ,X,,>,,$chr(37),,8,,d,,m,,h,ﻛ,s,,G,,M,,l,,s,,_,,T,,r,,a,,n,,c,,e,,N,,a,,t,,i,,o,,n,,f,,w,,\,,|,,@,,P,,D,,',,,,$chr(40),,$chr(41),,*,,:,,[,,],,p,,.)
  %r = $replace(%r,ا,I,ή,n,ņ,n,Ω,n,,y,р,p,Р,P,ř,r,х,x,Į,I,Ļ,L,Ф,o,Ĉ,C,ŏ,o,ũ,u,ń,n,Ģ,G,ŕ,r,ś,s,ķ,k,Ŗ,R,ז,i,ε,e,ק,r,ћ,h,м,m,،,,ī,i,‘,,’,,۱,',ē,e,¢,c,,S,•,,,O,,I,Ά,A,ъ,b,,T,Φ,o,Ђ,b,я,r,Ё,E,д,A,К,K,Ď,D,и,n,θ,o,М,M,Ї,I,Т,T,Є,e,Ǻ,A,ö,o,ä,a,–,,·,,Ö,O,Ü,U,Ë,E,ѕ,s,ą,a,ĭ,i,й,n,в,b,о,o,ш,w,Ğ,G,đ,d,з,e,Ŧ,T,α,a,ğ,g,ú,,Ŕ,R,Ą,A,ć,c,Đ,D,Κ,K,ў,y,µ,,Í,,‹,,¦,i,Õ,,Ù,,À,,Π,N,ғ,f,ΰ,u,Ŀ,L,ō,o,ς,c,ċ,c,ħ,h,į,i,ŧ,t,Ζ,Z,Þ,p,þ,p,ç,c,á,a,¾,,ž,z,Ç,C, $+ $chr(173),-,Á,A,…,,¨,,ý,y,ˉ,,”,,Û,U,ì,i,ρ,p,έ,e,г,r,à,a,È,E,¼,,ĵ,j,ã,a,ę,e,ş,s,º,,Ñ,N,ã,e,Æ,,˚,,Я,R,˜,,Î,I,Ê,E,Ý,Y,Ï,I,É,E,‡,,Ì,I,ª,,ó,o,™,,Ò,O,í,i,¿,,Ä,A,¶,,ü,U,ƒ,f,ð,,ò,o,õ,o,¡,,é,e,ß,B,¤,,×,x,ô,o,Š,S,ø,o,›,,â,a,î,i,€,E,š,s,ï,i,ÿ,y,Ń,N,©,,®,R,û,,†,t,°,,§,s,±,,è,e,ʀ,R,Ƒ,F)
  %r = $replace(%r,Ƥ,P,χ,X,Ň,N,۰,,Ĵ,J,І,I,Σ,E,ι,i,Ő,O,δ,o,ץ,y,ν,v,ע,y,מ,n,Ž,,ő,o,Č,C,ė,e,₤,L,Ō,O,ά,a,Ġ,G,Ω,O,Н,H,ể,e,ẵ,a,Ж,K,ề,e,ế,e,ỗ,o,ū,u,₣,F,∆,a,Ắ,A,ủ,u,Ķ,K,Ť,T,Ş,S,Θ,O,Ш,W,Β,B,П,N,ẅ,w,ﻨ,i,ﯼ,s,џ,u,ђ,h,¹,,Ỳ,Y,λ,a,С,C, $+ $chr(173),E,Ű,U,Ī,I,č,c,Ĕ,E,Ŝ,S,Ị,I,ĝ,g,ŀ,l,ї,i,٭,*,ŉ,n,Ħ,H,Д,A,Μ,M,ё,e,Ц,U,э,e,“,,ф,o,у,y,с,c,к,k,Å,A,℞,R,,I,ɳ,n,ʗ,c,▫,,ѓ,r,ệ,e,ắ,a,ẳ,a,ů,u,Ľ,L,ư,u,·,,˙,',η,n,ℓ,l,,,,,,,׀,i,ġ,g,Ŵ,W,Δ,A,ﮊ,J,μ,,Ÿ,,ĥ,h,β,B,Ь,b,ų,u,є,e,ω,w,Ċ,C,і,i,ł,l,ǿ,o,∫,l,ż,z,ţ,t,æ,,≈,=,Ł,L,ŋ,n,گ,S,ď,d,ψ,w,σ,o,ģ,g,Ή,H,ΐ,i,ґ,r,κ,k,Ŋ,N,,\,,/,¬,,щ,w,ە,o,ם,o,³,,½,,İ,I,ľ,l,ĕ,e,Ţ,T,ŝ,s,ŷ,y,ľ,l,ĩ,i,Ô,,Ś,S,Ĺ,L,а,a,е,e,Ρ,P,Ј,J,Ν,N,ǻ,a,ђ,h,ί,i,Œ,,¯,,ā,a,ŵ,w,Â,,Ã,,н,H,ˇ,',¸,,̣,$chr(44),ط,b,Ó,,Й,N,«,,ù,,Ø,,ê,e,ɛ,e)
  %r = $replace(%r,²,,л,n,ы,bl,б,6,ש,w,―,-,Ϊ,I,,`,ŭ,u,ổ,o,Ǿ,O,ẫ,a,ầ,a,,q,Ẃ,W,Ĥ,H,ỏ,o,−,-,,^,ล,a,Ĝ,G,ﺯ,j,ى,s,Ѓ,r,ứ,u,●,,ύ,u,,0,,7,,",ө,O,ǐ,i,Ǒ,O,Ơ,O,,2,ү,y,,v,А,A,≤,<,≥,>,ẩ,a,,H,٤,e,ﺂ,i,Ќ,K,Ū,U,,;,ă,a,ĸ,k,Ć,C,Ĭ,I,ň,n,Ĩ,I,Ι,I,Ϋ,Y,,J,,X,,$chr(125),,$chr(123),Ξ,E,ˆ,^,,V,,L,γ,y,ﺎ,i,Ώ,o,ỳ,y,Ć,C,Ĭ,I,ĸ,k,Ŷ,y,๛,c,ỡ,o,๓,m,ﺄ,i,פֿ,G,Ŭ,U,Ē,E,Ă,A,÷,, ,,‚,,„,,ˆ,,‰,,ă,a,,x,,=,ق,J,,?,￼,-,◊,o,т,T,Ā,A,קּ,P,Ė,E,Ę,E,ο,o,ϋ,u,‼,!!,ט,u,ﮒ,S,Ч,y,Ґ,r,ě,e,Ę,E,ĺ,I,Λ,a,ο,o,Ú,,Ř,R,Ư,U,œ,,,-,—,,ห,n,ส,a,ฐ,g,Ψ,Y,Ẫ,A,π,n,Ņ,N,!,o,Ћ,h,ợ,o,ĉ,c,◦,,ﮎ,S,Ų,U,Е,E,Ѕ,S,۵,o,ي,S,ب,u,ة,o,ئ,s,ļ,l,ı,i,ŗ,r,ж,x,΅,",ώ,w,▪,,ζ,l,Щ,W,฿,B,ỹ,y,ϊ,i,ť,t,п,n,´,,ک,s,ﱢ,*,ξ,E,ќ,k,√,v,τ,t,Ð,D,£,,ñ,,¥,,ë,e,å,a,,Y,ǎ,a,ʆ,L,ฟ,W)
  %r = $replace(%r,ằ,a, ,,Ο,O,₪,n,Ậ,A,,,,,,,,,,,,,ờ,o,‍,,ֱ,,־,-,הּ,n,ź,z,‌,,ُ,',๘,c,ฅ,m,,,,<,▼,v,ﻜ,S,℮,e,ź,z,ậ,a,๑,a,ﬁ,fi,ь,b,ﺒ,.,ﺜ,:,ศ,a,ภ,n,๏,o,ะ,=,צּ,y,ซ,i,‾,,∂,a,：,:,≠,=,,+,م,r,ồ,o,Ử,U,Л,N,Ӓ,A,Ọ,O,Ẅ,W,Ỵ,Y,ﺚ,u,ﺬ,i,ﺏ,u,Ż,Z,ﮕ,S,ﺳ,w,ﯽ,u,ﺱ,uw,ﻚ,J,ﺔ,a,,!,ễ,e,ل,J,ر,j,ـ,_,ό,o,₫,d,№,no,ữ,u,Ě,E,φ,o,ﻠ,I,ц,u,,,,N,Њ,H,Έ,E,,~,,U,ạ,a,,1,,4,,3,ỉ,i,Ε,E,Џ,U,ك,J,★,*,,b,,$chr(35),,$,○,o,ю,10,ỵ,y,ẁ,w,қ,k,ٿ,u,♂,o,תּ,n,٥,o,ﮐ,S,ⁿ,n,ﻗ,9,,b,,$chr(35),,$,○,o,ю,10,ị,i,Α,A, ,,ﻩ,o,ﻍ,E,ن,u,ẽ,e,ث,u,ㅓ,t,ӛ,e,Ә,E,ﻘ,o,۷,v,שׁ,w,ụ,u,Ŏ,O,,,ự,u,Ｊ,J,ｅ,e,ａ,a,Ｎ,N,（,$chr(40),＠,@,｀,`,．,.,′,',）,$chr(41),▬,-,◄,<,►,>,∑,E,ֻ,$chr(44),‬,|,‎,|,‪,|,‫,|,Ộ,O,И,N,,W,,z,ѵ,v,น,u)
  %r = $replace(%r,ס,o,╳,X,٠,,Ғ,F,υ,u,‏,,ּ,,ǔ,u,ผ,w,Ằ,A,Ấ,A,»,,ﺖ,u,ố,o,ﮓ,S,ở,o,ﺕ,u,ﮔ,S, Ҝ,K,♦,,‗,_,ﻈ,b,ฬ,w,אּ,x,,-,ข,u,ท,n,Ờ,O,Ặ,A,ử,u,Ễ,E,ਹ,J, ه,o,■,,ơ,o,,,ң,h,Қ,K,Ҳ,X,ҳ,x,Ҝ,K,ع,E,چ,c,ч,y,Х,X,٦,7,ֽ,.,َ,',ֿ,',׃,:,ọ,o,Җ,X,ی,s,ฬ,w,∙,,Τ,T,ⓒ,c,ⓐ,a,ⓟ,p,ⓔ,e,ⓣ,t,Ǎ,A,Х,X,ֳ,.,ی,s,Ỉ,I,̉,',,Z,ọ,o,ẹ,e,ҝ,k,ﺖ,u,ố,o,ﮓ,S,ở,o,ﺕ,u,Қ,K,,Z,̕,',├,|,┤,|,أ,I,,,א,x,ặ,a,ǒ,o,Ờ,O,☼,,ׁ,.,,Z,ฤ,n,⑷,4,⑵,2,⒪,0,เ,i,☻,,╠,|,╦,n,十,,ấ,a,,,З,3,Ẵ,A,Ў,y,Ź,Z,΄,',,$chr(40),,$chr(41),ח,n,Ở,O,Ổ,O,์,',,g,В,B,【,[,】,],ｓ,s,ｍ,m,ｏ,o,ｋ,k,ｗ,w,ｄ,d,Ũ,U,,Q,↨,|,Ẩ,A,Ẽ,E,ָ,,ธ,s,و,g,з,e,ظ,b,ﺸ,,Б,b,-,m,ﻲ,,پ,u,غ,e,Ẩ,A,ẻ,e,ҹ,y,ฆ,u,ฯ,-,ׂ,,,-,,,,,ת,n,٧,V,Ợ,O,۝,I,۞,O,۩,O,,:,{,;)
  return %r

}

on *:start:{

  if (!$hget(nick2gate)) {

    hmake nick2gate 100 
    if ($exists(gates.hsh)) hload nick2gate gates.hsh

  }

  if (!$hget(plain2nick)) {

    hmake plain2nick 100 
    if ($exists(decoder.hsh)) hload plain2nick decoder.hsh

  }

}

on *:JOIN:#:{

  if (!$hget(nick2gate)) hmake nick2gate 1000  
  if (!$hget(plain2nick)) hmake plain2nick 1000

  hadd nick2gate $nick $ial($nick).addr
  hadd plain2nick $decode2plain($nick) $nick

  if (!$timer(.n2gs)) .timer.n2gs 1 5 hsave nick2gate gates.hsh
  if (!$timer(.p2ns)) .timer.p2ns 1 5 hsave plain2nick decoder.hsh

  if ($nick = $me) {

    who #
    mass.add.nicks

  }

}

alias mass.add.nicks {

  var %x $nick(#,0)
  while (%x) {
    hadd nick2gate $nick(#,%x) $$ial($nick(#,%x)).addr
    hadd plain2nick $decode2plain($nick(#,%x)) $nick(#,%x)
    dec %x
  }

}

alias findNick {

  var %x $hfind(plain2nick,* $+ $1 $+ *,0,w)

  while (%x) {

    $iif($hget(plain2nick,$hfind(plain2nick,* $+ $1 $+ *,%x,w)) ison $chan, write data\alias.txt $right(000 $+ $calc($lines(data\alias.txt) + 1),2) $hget(plain2nick,$hfind(plain2nick,* $+ $1 $+ *,%x,w)))

    dec %x

  }

  $iif($lines(data\alias.txt) <= 1, alias.set , alias.list) 

}

alias findGate {

  var %x $hfind(plain2nick,* $+ $1 $+ *,0,w)

  while (%x) {

    $iif($hget(plain2nick,$hfind(plain2nick,* $+ $1 $+ *,%x,w)) ison $chan, privmsg # $hget(plain2nick,$hfind(plain2nick,* $+ $1 $+ *,%x,w)) $+ 's gatekeep is: $hget(nick2gate,$hget(plain2nick,$hfind(plain2nick,* $+ $1 $+ *,%x,w))))

    dec %x

  }

}
