;================================================================================
;----Room Favorites--------------------------------------------------------------
;================================================================================


menu @Clones {
  -
  Room Favorites: { dialog -m favs favs }
  -
}


dialog favs {
  title "Room Favorites"
  size -1 -1 231 133
  option dbu
  button "&Add Chan", 3, 177 18 37 12
  button "&Delete Chan", 4, 177 41 37 12
  button "&Join Chan", 5, 177 65 37 12
  box "", 6, 12 12 207 108
  list 7, 15 18 158 99, sort size vsbar
  button "OK/Cancel", 8, 177 105 37 12, ok cancel
  edit Channel Favorites, 1, 83 6 63 10, center
  icon 2, -47 -18 364 308,  Images\Favs.jpg, 0, noborder
  button "&Room Listings", 9, 177 89 37 12
  box "", 10, 172 12 47 91
  box "", 11, 6 2 220 127
  text "By &BytchAmy 2009", 12, 157 120 67 8, center
  icon 13, 24 109 203 157, Images\small.jpg, 0, noborder
}

alias favorites {
  .set %favorites $$?="Chat Room Name" 
  .write Settings/favorites.txt %favorites 
  .loadbuf -ro favs 7 Settings/favorites.txt 
}

on *:dialog:favs:init:*:{
  .timer -m 1 1 favs.an

  .loadbuf -ro favs 7 Settings/favorites.txt 
  .splay mepart.wav

  dll $mdx SetBorderStyle 2,7 staticedge
  dll $mdx SetMircVersion $version
  dll $mdx MarkDialog $dname
  dll dll\mdx.dll SetBorderStyle 1,2,6,7,10,11,12  14 50 Georgia Bold
  dll dll\mdx.dll SetColor $dname 1,2,6,7,10,11,12 text $rgb(%list1colour,%list2colour,%list3colour)
  dll $mdx SetFont $dname 1,2,6,7,10,11,12 40 Georgia Bold
  mdx SetFont 1,2,6,7,10,11,12 +a 12 100 Verdana

  colorize
}

on *:Dialog:favs:sclick:7: { .set %sel.room $did(7).seltext | /join %sel.room }
on *:Dialog:favs:sclick:3: { .favorites }
on *:Dialog:favs:sclick:4: { /write -ds $+ %sel.room Settings/favorites.txt | .loadbuf -ro favs 7 Settings/favorites.txt }
on *:Dialog:favs:sclick:5: { /join %sel.room | .loadbuf -ro favs 7 Settings/favorites.txt | /favs.die }
on *:Dialog:favs:sclick:8: { .splay zip.wav }
on *:Dialog:favs:sclick:9: { .channel.list GN }


alias favs.an {
  var %i 0
  while (%i <= 231) {
    dialog -srb favs -1 -1 %i %i
    var %t 1
    while (%t <= 133) inc %t
    inc %i
  }
  .timer -m 1 1 favs.tbar | .splay mepart.wav
}

alias favs {
  if ($dialog(favs)) {
    dialog -c favs favs
    dialog -mado favs favs
  }
  else { dialog -mado favs favs }
}

alias favs.die {
  var %i 231
  while (%i >= 0) {
    dialog -srb favs -1 -1 %i %i
    var %t 1
    while (%t <= 133) inc %t
    dec %i
  }
  dialog -c favs
}

alias -l favs.tbar {
  var %i 0
  while (%i <= 24) {
    timer.tbar 1 0 dialog -t favs $left(Room Favorites,%i)
    var %t 1
    while (%t <= 400) inc %t
    inc %i
  }
}
