;================================================================================
;----Ignore List-----------------------------------------------------------------
;================================================================================


#ignorelist on

on *:load: { addcp 49 icons\icon.icoIgnore List/ignorelist }
on *:unload: { remcp 49 }

alias uninstall.ignore.manager {
  unset %ignore.*
  unload -rs $scriptdir $+ ignore.mrc
}

alias -l ignore.settings {
  set %ignore.delay [ off ]
  set %ignore.delay.timer [ 60 ]
  set %ignore.switches.default [ 2 ]
  set %ignore.type.default [ 2 ]
  .ial on
}

alias ignorelist {
  if ($dialog(ignoreListDialog) == $null) { dialog -m ignoreListDialog ignoreListDialog }
  else { dialog  -v ignoreListDialog }
}

alias ignore.manager {
  set %ignore.nick [ $1 ]
  if ($dialog(ignoreDialog) == $null) { 
    dialog -m ignoreDialog ignoreDialog 
  }
  else {
    dialog  -v ignoreDialog
    setIgnore
  }
}

dialog ignoreDialog {
  title "Ignore Manager [/ignore.manager]"
  size -1 -1 200 125
  option dbu
  icon icons/icon.ico, 0
  text "Mask types:", 722, 5 3 37 7
  radio "", 723, 1 14 10 10, left
  edit "", 724, 16 13 130 10, autohs
  radio "", 725, 1 24 10 10, left
  edit "", 726, 16 23 130 10, autohs
  radio "", 727, 1 34 10 10, left
  edit "", 728, 16 33 130 10, autohs
  radio "", 729, 1 44 10 10, left
  edit "", 730, 16 43 130 10, autohs
  radio "", 731, 1 54 10 10, left
  edit "", 732, 16 53 130 10, autohs
  radio "", 733, 1 64 10 10, left
  edit "", 734, 16 63 130 10, autohs
  radio "", 735, 1 74 10 10, left
  edit "", 736, 16 73 130 10, autohs
  radio "", 737, 1 84 10 10, left
  edit "", 738, 16 83 130 10, autohs
  radio "", 739, 1 94 10 10, left
  edit "", 740, 16 93 130 10, autohs
  text "Ignore types:", 741, 152 3 35 10
  check "Privates", 742, 153 13 35 10
  check "Channel", 743, 153 23 35 10
  check "Notices", 744, 153 33 35 10
  check "Ctcps", 745, 153 43 35 10
  check "Invites", 746, 153 53 35 10
  check "Control codes", 747, 153 63 50 10
  text "Delay:", 748, 153 75 42 8
  edit "", 749, 153 83 15 10
  text "seconds", 750, 170 85 25 7
  check "Enabled", 751, 154 94 41 10
  button "Ignore", 720, 5 110 37 12, ok
  button "Cancel", 721, 45 110 37 12, cancel
  button "Save settings", 752, 85 110 39 12
  button "Restore factory settings", 753, 127 110 68 12
  icon 1, -2 -1 204 132, Images\I-Manager.jpg, 0, noborder
}


alias -l  setIgnore {
  var %ign.i = 1
  var %ignore.address.did = 724
  while (%ign.i <= 9) {
    did -ra ignoreDialog %ignore.address.did $address(%ignore.nick,%ign.i)
    inc %ign.i 1
    inc %ignore.address.did 2
  }
  did -c ignoreDialog $calc(721 + 2 * %ignore.type.default)
  unset %ignore.nick
  if (%ignore.delay == on) { did -c ignoreDialog 751 | did -rae ignoreDialog 749 %ignore.delay.timer }
  else { did -u ignoreDialog 751 | did -rab ignoreDialog 749 %ignore.delay.timer }

  %ign.i = 1
  while (%ign.i <= $numtok(%ignore.switches.default,44)) {
    did -c ignoreDialog $calc(741 + $gettok(%ignore.switches.default,%ign.i,44))
    inc %ign.i 1
  }
}


ON *:DIALOG:ignoreDialog:INIT:0:setIgnore

ON *:DIALOG:ignoreDialog:SCLICK:751:{
  if ($did(751).state == 1) { did -e ignoreDialog 749 %ignore.delay.timer }
  if ($did(751).state == 0) { did -b ignoreDialog 749 %ignore.delay.timer }
}

ON *:DIALOG:ignoreDialog:SCLICK:753:{ 
  ignore.settings  
  var %ign.i = 1
  var %ignore.address.did = 723
  while (%ign.i <= 9) {
    did -u ignoreDialog %ignore.address.did
    inc %ign.i 1
    inc %ignore.address.did 2
  }
  %ign.i = 1
  %ignore.address.did = 742
  while (%ign.i <= 6) {
    did -u ignoreDialog %ignore.address.did
    inc %ign.i 1
    inc %ignore.address.did 1
  }
  did -c ignoreDialog $calc(721 + 2 * %ignore.type.default)
  if (%ignore.delay == on) { did -c ignoreDialog 751 | did -rae ignoreDialog 749 %ignore.delay.timer }
  else { did -u ignoreDialog 751 | did -rab ignoreDialog 749 %ignore.delay.timer }

  %ign.i = 1
  while (%ign.i <= $numtok(%ignore.switches.default,44)) {
    did -c ignoreDialog $calc(741 + $gettok(%ignore.switches.default,%ign.i,44))
    inc %ign.i 1
  }
}

ON *:DIALOG:ignoreDialog:SCLICK:752:{
  var %ign.i = 1
  var %ignore.address.did = 723
  while (%ign.i <= 9) {
    if ($did(%ignore.address.did).state == 1) { set %ignore.type.default [ %ign.i ] } 
    inc %ign.i 1
    inc %ignore.address.did 2
  }
  %ign.i = 1
  %ignore.address.did = 742
  var %ignore.switches.save
  var %ignore.switches.abbr
  while (%ign.i <= 6) {
    if ($did(%ignore.address.did).state == 1) { 
      if (Privates isin $did(%ignore.address.did).text) { %ignore.switches.abbr = 1 }  
      if (Channel isin $did(%ignore.address.did).text) { %ignore.switches.abbr = 2 }  
      if (Notices isin $did(%ignore.address.did).text) { %ignore.switches.abbr = 3 }  
      if (Ctcps isin $did(%ignore.address.did).text) { %ignore.switches.abbr = 4 }  
      if (Invites isin $did(%ignore.address.did).text) { %ignore.switches.abbr = 5 }  
      if (Control isin $did(%ignore.address.did).text) { %ignore.switches.abbr = 6 }  
      %ignore.switches.save = %ignore.switches.save $+ $chr(44) $+ %ignore.switches.abbr
    }
    inc %ign.i 1
    inc %ignore.address.did 1
  }
  set %ignore.switches.default [ $right(%ignore.switches.save,$calc($len(%ignore.switches.save) - 1)) ]

  if ($did(751).state == 1) { set %ignore.delay [ on ] }
  else { set %ignore.delay [ off ] }
  if (($did(749).text != $null) && ($did(749).text isnum) && ($did(749).text >= 0)) { set %ignore.delay.timer [ $did(749).text ] }
  else { 
    if ($did(751).state == 1) { did -rae ignoreDialog 749 %ignore.delay.timer  }
    else { did -rab ignoreDialog 749 %ignore.delay.timer  }
  } 
}

ON *:DIALOG:ignoreDialog:SCLICK:721:close -x

ON *:DIALOG:ignoreDialog:SCLICK:720:{
  var %ign.i = 1
  var %ignore.address.did = 723
  var %ignore.mask
  while (%ign.i <= 9) {
    if ($did(%ignore.address.did).state == 1) { %ignore.mask = $did($calc(%ignore.address.did + 1)).text } 
    inc %ign.i 1
    inc %ignore.address.did 2
  }
  %ign.i = 1
  %ignore.address.did = 742
  var %ignore.switches
  var %ignore.switches.abbr
  while (%ign.i <= 6) {
    if ($did(%ignore.address.did).state == 1) { 
      if (Privates isin $did(%ignore.address.did).text) { %ignore.switches.abbr = p }  
      if (Channel isin $did(%ignore.address.did).text) { %ignore.switches.abbr = c }  
      if (Notices isin $did(%ignore.address.did).text) { %ignore.switches.abbr = n }  
      if (Ctcps isin $did(%ignore.address.did).text) { %ignore.switches.abbr = t }  
      if (Invites isin $did(%ignore.address.did).text) { %ignore.switches.abbr = i }  
      if (Control isin $did(%ignore.address.did).text) { %ignore.switches.abbr = k }  
      %ignore.switches = %ignore.switches $+ %ignore.switches.abbr
    }
    inc %ign.i 1
    inc %ignore.address.did 1
  }
  if ((%ignore.mask != $null) && (%ignore.switches)) { 
    if ($did(751).state == 1) { 
      if (($did(749).text != $null) && ($did(749).text isnum) && ($did(749).text >= 0)) { ignore - $+ %ignore.switches $+ u $+ $did(749).text %ignore.mask }
      else { echo -a $cxs(3) $+  $+ %xsbrack $+  $+ $cxs(2) Ignore cancelled wrong value for the delay }
    }
    else { ignore - $+ %ignore.switches %ignore.mask }
  }
  else { echo -a $cxs(3) $+  $+ %xsbrack $+  $+ $cxs(2) $+ ::: Ignore cancelled no ignore address or ignore type switch(es) selected }
}

dialog ignoreListDialog {
  title "Ignore List [/Ignorelist]"
  size -1 -1 224 109
  option dbu
  icon icons/icon.ico, 0
  list 761, 5 5 154 91
  text "Applied ignore type(s):", 765, 164 6 57 9
  check "Privates", 766, 165 17 35 10
  check "Channel", 767, 165 27 35 10
  check "Notices", 768, 165 37 35 10
  check "Ctcps", 769, 165 47 35 10
  check "Invites", 770, 165 57 35 10
  check "Control codes", 771, 165 67 50 10
  check "Enable ignore", 772, 165 95 50 10
  button "Remove", 762, 44 94 37 12
  button "Clear all", 763, 83 94 37 12
  button "Update", 764, 5 94 37 12
  button "OK", 760, 122 94 37 12, ok
}

alias -l  setIgnoreList {
  %ignore.number = $ignore(0)
  if (%ignore.number != 0) {
    var %ign.i = 1
    while (%ign.i <= %ignore.number) {
      did -a ignoreListDialog 761 $ignore(%ign.i)
      inc %ign.i 1
    }
    ;did -f ignoreListDialog $did(761,1)
    set.ignore.types  1
  }
  else {
    var %message = Ignore list is empty
    did -a ignoreListDialog 761 %message
  }
  if ($ignore == $true) { did -c ignoreListDialog 772 }
  else { did -u ignoreListDialog 772  }
}

alias -l  set.ignore.types {
  var %ign.j = 766
  while (%ign.j <= 771) {
    did -u ignoreListDialog %ign.j
    inc %ign.j 1
  }      
  %ign.j = 1 
  var %types.max = $numtok($ignore($1).type,44)
  while (%ign.j <= %types.max) {
    if (private isin $gettok($ignore($1).type,%ign.j,44)) { did -c ignoreListDialog 766 }  
    if (channel isin $gettok($ignore($1).type,%ign.j,44)) { did -c ignoreListDialog 767 }  
    if (notice isin $gettok($ignore($1).type,%ign.j,44)) { did -c ignoreListDialog 768 }  
    if (ctcp isin $gettok($ignore($1).type,%ign.j,44)) { did -c ignoreListDialog 769 }  
    if (invite isin $gettok($ignore($1).type,%ign.j,44)) { did -c ignoreListDialog 770 }  
    if (codes isin $gettok($ignore($1).type,%ign.j,44)) { did -c ignoreListDialog 771 }  
    inc %ign.j 1
  }
}

ON *:DIALOG:ignoreListDialog:INIT:0:setIgnoreList

ON *:DIALOG:ignoreListDialog:SCLICK:761:set.ignore.types $did(761).sel

ON *:DIALOG:ignoreListDialog:SCLICK:762:{
  var %no.ignore = Ignore list is empty
  if (($did(761).sel != $null) && (%no.ignore !isin $did(761,$did(761).sel))) { 
    var %selected.item = $did(761).sel
    ignore -r $did(761,%selected.item)
    did -d ignoreListDialog 761 $did(761).sel 
    var %ign.j = 766
    while (%ign.j <= 771) {
      did -u ignoreListDialog %ign.j
      inc %ign.j 1
    }     
  }
  else { echo -a $cxs(3) $+  $+ %xsbrack $+  $+ $cxs(2) $+ ::: Error no entry selected }
}

ON *:DIALOG:ignoreListDialog:SCLICK:763:{
  var %no.ignore = Ignore list is empty
  var %ignore.number = $ignore(0)
  if  ((%ignore.number != 0) && (%no.ignore !isin $did(761,$did(761).sel))) {
    var %ign.i = 1
    while (%ign.i <= $ignore(0)) {
      did -d ignoreListDialog 761 1
      inc %ign.i 1
    }
    ignore -r
    did -a ignoreListDialog 761 Ignore list is empty
  }
  else { did -ra ignoreListDialog 761 Ignore list is empty }
  var %ign.j = 766
  while (%ign.j <= 771) {
    did -u ignoreListDialog %ign.j
    inc %ign.j 1
  }     
}

ON *:DIALOG:ignoreListDialog:SCLICK:764:{
  var %no.ignore = Ignore list is empty
  if (($did(761).sel != $null) && (%no.ignore !isin $did(761,$did(761).sel))) { 
    var %update.switches
    var %switch.selected = 0
    if ($did(766).state == 1) { %update.switches = %update.switches $+ p | inc %switch.selected 1 }
    if ($did(767).state == 1) { %update.switches = %update.switches $+ c | inc %switch.selected 1 }
    if ($did(768).state == 1) { %update.switches = %update.switches $+ n | inc %switch.selected 1 }
    if ($did(769).state == 1) { %update.switches = %update.switches $+ t | inc %switch.selected 1 }
    if ($did(770).state == 1) { %update.switches = %update.switches $+ i | inc %switch.selected 1 }
    if ($did(771).state == 1) { %update.switches = %update.switches $+ k | inc %switch.selected 1 }
    if (%switch.selected >= 1) { 
      var %selected.item = $did(761).sel
      .ignore -r $did(761,%selected.item)
      ignore - $+ %update.switches $did(761,%selected.item)
      did -c ignoreListDialog 772
    }    
    else { echo -a $cxs(3) $+  $+ %xsbrack $+  $+ $cxs(2) $+ ::: Update ignore canceled. No ignore type were selcted. }
  }
  else { echo -a $cxs(3) $+  $+ %xsbrack $+  $+ $cxs(2) $+ ::: Update ignore canceled. No valid user were selcted. }
}

#ignorelist end
