;------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------
;------------[ Message Blocker ]-----------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------





on *:LOAD:{ set %pwm $=w Off | pwhispm.set  
}

on *:UNLOAD:{ set %pwm $=w On 
}


on *:text:*:?:{ /splay pm.wav 
}

dialog msgblock_ {
  title "Message Blocker [/msgblock]"
  size -1 -1 171 178
  option dbu
  icon icons\error.ico, 0
  box "", 1, 4 9 82 100
  check "Block all queries", 2, 8 14 8 10
  check "Block if msg contains:", 3, 8 26 8 10
  list 4, 8 38 74 50, sort size hsbar vsbar
  button "&Add", 5, 8 92 30 11
  button "&Remove", 6, 51 92 30 11
  box "", 7, 85 9 82 100
  check "Users in notify list", 8, 89 14 7 10
  check "Friends:", 9, 89 26 8 10
  list 10, 89 38 74 50, sort size hsbar vsbar
  button "&Add", 11, 90 92 30 11
  button "&Remove", 12, 133 92 30 11
  box "", 13, 4 114 163 44
  check "Send reject notice:", 14, 8 120 8 10
  edit "", 15, 63 120 100 10, autohs
  check "Echo rejected queries to active window", 16, 8 132 8 10
  check "Ignore queries for:", 19, 8 144 7 10
  edit "", 20, 63 144 26 10
  text "seconds", 21, 91 146 20 8
  button "&OK", 17, 87 163 38 12, ok
  button "&Cancel", 18, 128 163 38 12, cancel
  text "Block all queries", 22, 16 15 42 8
  text "Block if msg contains:", 23, 16 27 53 8
  text "Block", 24, 4 4 15 8, center
  text "Exempt", 25, 85 4 24 8, center
  text "Options", 26, 4 109 25 8, center
  text "Send reject notice:", 27, 15 121 47 8, center
  text "Echo rejected queries to active window", 28, 15 133 97 8, center
  text "Ignore queries for:", 29, 15 145 47 8, center
  text "Users in notify list", 30, 96 15 45 8
  text "Friends:", 31, 96 27 22 8
  icon 32, -9 -2 183 182, images\back.jpg, 0, noborder
}


on *:dialog:msgblock_:*:*:{
  if ($devent == init) {
    if ($readini($mb,block,all)) { did -c $dname 2 }
    if ($readini($mb,block,isin)) { did -c $dname 3 }
    .udlist_ 4 block words
    if ($readini($mb,exempt,notify)) { did -c $dname 8 }
    if ($readini($mb,exempt,list)) { did -c $dname 9 }
    .udlist_ 10 exempt friends
    if ($readini($mb,options,reject)) { did -c $dname 14 }
    if ($readini($mb,options,echo)) { did -c $dname 16 }
    did -a $dname 15 $readini($mb,options,notice)
    if ($readini($mb,options,ignore)) { did -c $dname 19 }
    did -a $dname 20 $readini($mb,options,secs)
    did -f $dname 17
  }
  if ($devent == sclick) {
    if ($did == 2) && ($did(2).state == 1) { did -u $dname 3 }
    if ($did == 3) && ($did(3).state == 1) { did -u $dname 2 }
    if ($did == 5) {
      var %t = $$?="Enter text (wildcards allowed) $crlf Separate multiple entries with a comma:"
      if ($numtok(%t,32) > 1) { %t = $replace(%t,$chr(32),$chr(160)) }
      .writeini $mb block words $iif($readini($mb,block,words),$+($ifmatch,$chr(44),%t),%t)
      udlist_ 4 block words
    }
    if ($did == 6) {
      var %tmp = $did(4).seltext
      if (%tmp) {
        if ($remtok($readini($mb,block,words),%tmp,44)) { 
          .writeini $mb block words $ifmatch 
        }
        else .remini $mb block words
        .udlist_ 4 block words
      }
    }
    if ($did == 11) {
      var %t = $$?="Enter nick/mask (wildcards allowed) $crlf Separate multiple entries with a comma:"
      if ($chr(32) !isin %t) {
        .writeini $mb exempt friends $iif($readini($mb,exempt,friends),$+($ifmatch,$chr(44),%t),%t)
        udlist_ 10 exempt friends
      }
    }
    if ($did == 12) {
      var %tmp = $did(10).seltext
      if (%tmp) {
        if ($remtok($readini($mb,exempt,friends),%tmp,44)) { 
          .writeini $mb exempt friends $ifmatch 
        }
        else .remini $mb exempt friends
        .udlist_ 10 exempt friends
      }
    }
    if ($did == 17) {
      ; OK button
      .writeini $mb block all $iif($did(2).state == 1,$true,$false)
      .writeini $mb block isin $iif($did(3).state == 1,$true,$false)
      .writeini $mb exempt notify $iif($did(8).state == 1,$true,$false)
      .writeini $mb exempt list $iif($did(9).state == 1,$true,$false)
      .writeini $mb options reject $iif($did(14).state == 1,$true,$false)
      .writeini $mb options notice $iif($did(15),$ifmatch,$readini($mb,options,notice))
      .writeini $mb options echo $iif($did(16).state == 1,$true,$false)
      .writeini $mb options ignore $iif($did(19).state == 1,$true,$false)
      .writeini $mb options secs $iif($did(20) isnum 1-,$ifmatch,$readini($mb,options,secs))
    }
  }
}
alias -l udlist_ {
  var %a = 1
  did -r $dname $1
  while ($gettok($readini($mb,$2,$3),%a,44)) {
    did -az $dname $1 $ifmatch
    inc %a
  }
}
alias -l match_text {
  ; find the god-like variable
  ; hint - it rhymes with 'spoonman'
  var %i = $numtok($readini($mb,block,words),44),%moonman
  while (%i > 0) {
    %moonman = $+(*,$replace($gettok($readini($mb,block,words),%i,44),$chr(160),$chr(32)),*) 
    if ($wildtok($1-,%moonman,1,44)) {
      return $true
    }
    dec %i
  }
}
alias -l isfriend {
  var %i = $numtok($readini($mb,exempt,friends),44),%j
  while (%i > 0) {
    %j = $gettok($readini($mb,exempt,friends),%i,44)
    if (%j iswm $address($1,5)) || ($1 == %j) { return $true }
    dec %i
  }
  return $false
}
alias -l block {
  var %i,%j
  if ($isfriend($1)) && ($readini($mb,exempt,list)) { %i = $true }
  if ($1 isnotify) && ($readini($mb,exempt,notify)) { %j = $true }
  if (%i) || (%j) { return $false }
  else { return $true }
}
alias msgblock dialog $iif($dialog(msgblock_),-v,-m) msgblock_ msgblock_
on ^*:open:?:{
  if ($readini($mb,block,all)) {
    if ($block($nick)) {
      if ($readini($mb,options,reject)) { .notice $nick $readini($mb,options,notice) }
      if ($readini($mb,options,echo)) { echo -at $pre Rejected query from  $+ $nick $+ : $1- }
      if ($readini($mb,options,ignore)) { .ignore $+(-pu,$readini($mb,options,secs)) $nick 2 }
      haltdef
    }
  }
  elseif ($readini($mb,block,isin)) && ($match_text($1-)) {
    if ($block($nick)) {
      if ($readini($mb,options,reject)) { .notice $nick $readini($mb,options,notice) }
      if ($readini($mb,options,echo)) { echo -at $pre Rejected query from  $+ $nick $+ : $1- }
      if ($readini($mb,options,ignore)) { .ignore $+(-pu,$readini($mb,options,secs)) $nick 2 }
      haltdef
    }
  }
}
alias -l mb return $+(",$scriptdirmsgblock.ini,")
