;================================================================================
;----MP3 Player------------------------------------------------------------------
;================================================================================


dialog mp3play {
  title "Mp3 Player System"
  size -1 -1 156 97
  icon images/icon1.ico
  option dbu
  text " Mp3 Player System " 2, 48 2 60 7, Center  Disable
  text "volume", 4, 2 52 17 7
  button "+", 5, 20 52 6 7
  button "Play", 6, 3 25 25 12
  button "Pause", 7, 126 25 25 12
  button "-", 8, 26 52 6 7
  button "Resume", 9, 102 25 25 12
  box "", 10, 2 60 152 22
  button "Stop", 11, 77 25 25 12
  button "Add file", 12, 3 67 25 10
  button "Next", 13, 28 25 25 12
  button "Add dir", 14, 28 67 25 10
  button "Previous", 15, 53 25 25 12
  button "Del file", 16, 53 67 25 10
  button "Clear", 17, 78 67 25 10
  button "Close", 18, 128 84 25 12
  box "", 19, 2 18 150 22
  button "Save", 20, 103 67 25 10
  button "Load", 21, 128 67 25 10
  check "Random", 22, 94 52 7 7
  check "Continous", 23, 58 52 7 7
  check "Repeat", 24, 125 52 6 7
  check "Mute", 25, 34 52 7 7
  edit "", 26, 5 42 146 9
  button "Close", 27, 128 84 25 12, hide
  text "Mute", 1, 40 52 17 7
  text "Continous", 3, 65 52 27 7
  text "Random", 28, 101 52 22 7
  text "Repeat", 29, 132 52 23 7
}
on *:DIALOG:mp3play:init:*: {
  dll $mdx SetBorderStyle 2,4,1,3,28,29 staticedge
  dll $mdx SetMircVersion $version 
  dll $mdx MarkDialog $dname
  dll $mdx SetBorderStyle 2,4,1,3,28,29 staticedge
  dll dll\mdx.dll SetColor $dname 2,4,1,3,28,29 text $rgb(%list1colour,%list2colour,%list3colour)
  dll $mdx SetFont $dname 2,4,1,3,28,29 Georgia Bold

  colorize

  set %cdsp 1
  if (%mutemp3 == $null) { set %mutemp3 }
  if (%mutemp3 == $chr(149)) { did -c mp3play 25 }
  if (%mp3continuous == $null) { set %mp3continuous off }
  if (%mp3continuous == on) { did -c mp3play 23 }
  if (%mp3shuffle == $null) { set %mp3shuffle off | set %mp3shufflemark }
  if (%mp3shuffle == on) { set %mp3shufflemark $chr(149) | did -c mp3play 22 }
  if (%mp3repeat == $null) { set %mp3repeat off | set %mp3repeatmark }
  if (%mp3repeat == on) { set %mp3repeatmark $chr(149) | did -c mp3play 24 }
  if (%currentplaying != $null) {
    did -o mp3play 26 1 %currentplaying
  }
}
on *:DIALOG:mp3play:sclick:*: {
  if ($did == 18) { mp3playup }
  if ($did == 25) { volmute }
  if ($did == 23) {
    if (%mp3continuous == on) { set %mp3continuous off | halt }
    if (%mp3continuous == off) { set %mp3continuous on | halt }
  }
  if ($did == 22) {
    if (%mp3shuffle == on) { set %mp3shuffle off | halt }
    if (%mp3shuffle == off) { set %mp3shuffle on  | halt }
  }
  if ($did == 24) {
    if (%mp3repeat == on) { set %mp3repeat off | halt }
    if (%mp3repeat == off) { set %mp3repeat on | halt }
  }
  if ($did == 6) { plmp3 }
  if ($did == 7) { .splay pause }
  if ($did == 9) { .splay resume }
  if ($did == 5) { volup }
  if ($did == 8) { voldown }
  if ($did == 11) { .cline 14 @PlayList %currentmp3line | /.splay stop }
  if ($did == 13) { mp3seek nextmp3 }
  if ($did == 15) { mp3seek prevmp3 }
  if ($did == 12) { addmp3file }
  if ($did == 14) { addmp3dir }
  if ($did == 16) { delmp3 }
  if ($did == 17) { /set %totalmp3line | /clear @PlayList | titlebar @PlayList : 0 track }
  if ($did == 20) { mp3plsfile save }
  if ($did == 21) { mp3plsfile load }
}
alias mp3player {
  window -kl @PlayList
  clear @PlayList
  if ( %mp3dir == $null ) { set %mp3dir $$sdir(c:\,MP3 Directory) }
  titlebar @PlayList : $$findfile(%mp3dir,*.mp3,0,aline 14 @PlayList $1-) tracks
  .splay stop
  set %currentmp3line 1
}
alias volup {
  set %currentvolume $vol(mp3)
  inc %currentvolume 5000
  if ( %currentvolume > 65535 ) { set %currentvolume 65535 }
  vol -p %currentvolume
}
alias voldown {
  set %currentvolume $vol(mp3)
  dec %currentvolume 5000
  if ( %currentvolume < 0 ) { set %currentvolume 0 }
  vol -p %currentvolume
}
alias volmute {
  if ( $vol(mp3).mute == $false ) {
    vol -pu1 | set %mutemp3 $chr(149)
  }
  else { vol -pu2 | set %mutemp3 }
}
alias mp3seek {
  if ( $1 == next ) {
    if ( $inmp3 != $false ) {
      set %mp3len $inmp3.length
      set %mp3pos $inmp3.pos
      .splay seek $calc( %mp3pos + 250 )
      if ( %mp3pos > %mp3len ) { .splay seek %mp3len }
    }
  }
  if ( $1 == prev ) {
    if ( $inmp3 != $false ) {
      set %mp3len $inmp3.length
      set %mp3pos $inmp3.pos
      .splay seek $calc( %mp3pos - 250 )
      if ( %mp3pos > %mp3len ) { .splay seek 0 }
    }
  }
  if ( $1 == nextmp3 ) {
    cline 14 @PlayList %currentmp3line
    inc %currentmp3line
    if ( %currentmp3line > %totalmp3line ) { set %currentmp3line 1 }
    cline 1 @PlayList %currentmp3line
    .splay $line(@PlayList,%currentmp3line) 
    $mp3rview
  }
  if ( $1 == prevmp3 ) {
    cline 14 @PlayList %currentmp3line
    if ( %currentmp3line == 1 ) { goto play }
    dec %currentmp3line
    :play
    cline 1 @PlayList %currentmp3line
    .splay $line(@PlayList,%currentmp3line) 
    $mp3rview
  }
}
alias id3info {
  window -lmk @Mp3Info 80 80 400 145
  aline @Mp3Info 14Filename:14 $nopath($sline(@PlayList,1))
  aline @Mp3Info 14Path:14 $nofile($sline(@PlayList,1))
  aline @Mp3Info 14Artist:14 $mp3($sline(@PlayList,1)).artist
  aline @Mp3Info 14Title:14 $mp3($sline(@PlayList,1)).title
  aline @Mp3Info 14Album:14 $mp3($sline(@PlayList,1)).album
  aline @Mp3Info 14Bitrate:14 $mp3($sline(@PlayList,1)).bitrate kbps 
  aline @Mp3Info 14Sample:14 $mp3($sline(@PlayList,1)).sample khz 
  aline @Mp3Info 14Mode:14 $mp3($sline(@PlayList,1)).mode
  aline @Mp3Info 14Length:14 $duration($int($calc( $file($sline(@PlayList,1)).size / 15876.24752 - 2)))
  .timerclose 1 17 /window -c @Mp3Info
}
alias mp3help {
  window -lmk @Mp3Help 50 50 200 225
  aline 1 @Mp3Help 14Mp3 Player of $logo
  aline @Mp3Help       15Shortcut Keys :
  aline @Mp3Help 4 z       : 14Previous Mp3 Play
  aline @Mp3Help 4 x       : 14Play selected Mp3
  aline @Mp3Help 4 c       : 14Pause Mp3 play
  aline @Mp3Help 4 f        : 14Resume Mp3 play
  aline @Mp3Help 4 v       : 14Stop Mp3 play
  aline @Mp3Help 4 b       : 14Next Mp3 Play
  aline @Mp3Help 4 a       : 14Seeking previous in mp3
  aline @Mp3Help 4 s       : 14Seeking next in mp3
  aline @Mp3Help 4 +       : 14Increase Volume
  aline @Mp3Help 4 -       : 14Decrease Volume
  aline @Mp3Help 4  *       : 14Mute Volume
  aline @Mp3Help 4 Del    : 14Delete selected Mp3
  aline @Mp3Help 4 Enter : 14Play selected Mp3
  .timerclose 1 17 /window -c @Mp3Help
}
on 1:keydown:@PlayList:*: {
  if ( $keychar == x ) { plmp3 }
  if ( $keychar == c ) { .splay pause }
  if ( $keychar == v ) { cline 15 @PlayList %currentmp3line | .splay stop }
  if ( $keychar == f ) { .splay resume }
  if ( $keyval == 46 ) { delmp3 }
  if ( $keyval == 107 ) { volup }
  if ( $keyval == 109 ) { voldown }
  if ( $keyval == 106 ) { volmute }
  if ( $keyval == 65 ) { mp3seek prev }
  if ( $keyval == 83 ) { mp3seek next }
  if ( $keyval == 90 ) { mp3seek prevmp3 }
  if ( $keyval == 66 ) { mp3seek nextmp3 }
}
on *:mp3end: {
  if ( $window(@PlayList).state != $null ) && ( %totalmp3line != 0 ) && ( %mp3continuous == ON ) {
    if (%mp3repeat == ON ) { goto play }
    cline 14 @PlayList %currentmp3line
    if ( %mp3shuffle == ON ) { 
      set %totalmp3line $line(@PlayList,0)
      set %currentmp3line $rand(1,%totalmp3line)
      goto play
    }
    inc %currentmp3line
    if ( %currentmp3line > %totalmp3line ) { set %currentmp3line 1 }
    :play
    cline 1 @PlayList %currentmp3line
    .splay $line(@PlayList,%currentmp3line) 
    $mp3rview
  }
}
on 1:close:@PlayList: {
  set %totalmp3line $line(@PlayList,0)
  set %currentline 1
  set %plsfilename playlist
  write -c %plsfilename
  :next
  write %plsfilename $line(@PlayList,%currentline)
  inc %currentline
  if ( %currentline > %totalmp3line ) { goto end }
  goto next
  :end
  mp3stopexit
}
alias mp3stopexit {
  if ( %mp3stopexit == ON ) { .splay stop | set %currentplaying }
}
alias plmp3 {
  .set %totalmp3line $line(@PlayList,0)
  .splay stop
  .if ( $sline(@PlayList,1) == $null ) { halt }
  .if ( %currentmp3line == $null ) { set %currentmp3line 1 }
  .cline 14 @PlayList %currentmp3line
  .set %currentmp3line $sline(@PlayList,1).ln
  .cline 1 @PlayList %currentmp3line
  .splay $sline(@PlayList,1) | $mp3rview
}
alias addmp3dir { 
  set %totalmp3line $line(@PlayList,0)
  set %addedmp3 $$findfile($$sdir(c:\,MP3 Directory),*.mp3,0,aline 15 @PlayList $1-)
  set %totalmp3line $calc(%totalmp3line + %addedmp3)
  titlebar @PlayList : %totalmp3line tracks
}
alias addmp3file { 
  set %totalmp3line $line(@PlayList,0)
  aline 14 @PlayList $$sfile(c:\*.mp3,Add File to PlayList,Add)
  inc %totalmp3line
  titlebar @PlayList : %totalmp3line tracks
}
alias delmp3 {
  if ( $sline(@PlayList,1) != $null ) {
    set %totalmp3line $line(@PlayList,0)
    dline @PlayList $sline(@PlayList,1).ln
    dec %totalmp3line
    titlebar @PlayList : %totalmp3line tracks
  }
}
menu @PlayList {
  dclick:/plmp3
   $chr(157) Mp3 Player $chr(157) 𺰘: { mp3playset }
  -
  $iif($sline(@PlayList,0) == $null, $style(2))  $chr(157) File Info $chr(157) 𺰘: { /id3info }
  -
   $chr(157) Help $chr(157) 𺰘: { /mp3help }
   $chr(157) Exit $chr(157) 𺰘: { /window -c @PlayList | mp3stopexit }
}

alias mp3plsfile {
  if ( $1 == save ) {
    if ( $window(@PlayList).state != $null ) {
      set %totalmp3line $line(@PlayList,0)
      set %currentline 1
      set %plsfilename $$sfile($mircdir,Enter Filename,Save)
      write -c %plsfilename
      :next
      write %plsfilename $line(@PlayList,%currentline)
      inc %currentline
      if ( %currentline > %totalmp3line ) { goto end }
      goto next
      :end
    }
  }
  if ( $1 == load ) {
    if ( $window(@PlayList).state != $null ) {
      clear @PlayList
      set %plsfilename $$sfile($mircdir,Choose a PlayList File,Load)
      set %totalplsline $lines(%plsfilename)
      set %currentline 1
      :next
      aline 15 @PlayList $read -l $+ %currentline %plsfilename
      inc %currentline
      if ( %currentline > %totalplsline ) { goto end }
      goto next
      :end
      .splay stop
      set %totalmp3line $line(@PlayList,0)
      titlebar @PlayList : %totalmp3line tracks
    }
  }
}
