;================================================================================
;----Protection Options----------------------------------------------------------
;================================================================================


alias options { dialog -m coptions coptions }

dialog coptions {
  title "Channel Options - [/options]"
  size -1 -1 154 154
  option dbu
  combo 1, 29 1 124 16, drop
  text "Channel", 2, 2 3 25 8
  box "", 3, 1 10 153 130
  list 4, 3 16 148 111, size
  button "Ok", 5, 93 142 28 11, default ok
  button "Cancel", 6, 123 142 28 11, cancel
  button "Add/Rem Chan", 8, 3 142 44 11, default
  button "Turn Off", 10, 123 128 28 10
  box "Channels Not Using Default Set-Up", 12, 156 1 149 153
  list 13, 159 8 143 130, size
  button "Remove", 14, 272 140 30 11
  button "Add", 11, 240 140 30 11
  combo 15, 160 140 78 50, edit drop
  button "Turn On", 9, 93 128 28 10
  button "Options", 7, 3 128 44 10, disabled

}

on *:dialog:coptions:init:0: {
  dll $mdx SetBorderStyle 5,6,7,8,9,10,11,14 staticedge
  dll $mdx SetMircVersion $version 
  dll $mdx MarkDialog $dname
  dll $mdx SetBorderStyle 5,6,7,8,9,10,11,14 staticedge
  dll dll\mdx.dll SetColor $dname 3,6,8,20,21,2 text $rgb(%list1colour,%list2colour,%list3colour)
  dll $mdx SetFont $dname 3,6,8,20,21,2 40 Georgia Bold

  colorize

  var %x = 1, %y = blah
  while (%x <= $ini($settings(chanoptions.txt),0)) {
    did -a $dname 1 $ini($settings(chanoptions.txt),%x)
    if ($ini($settings(chanoptions.txt),%x) != Default) did -a $dname 13 $ini($settings(chanoptions.txt),%x)
    if ($active == $ini($settings(chanoptions.txt),%x)) { var %y = %x }
    inc %x
  }
  did -c $dname 1 $iif(%y != blah,%y,1)

  dll $mdx SetControlMDX $dname 4 listview report showsel rowselect nosortheader > $mdx.view
  did -i $dname 4 1 headerdims 40:1 90:2 300:3
  did -i $dname 4 1 headertext + 0 $chr(32) $+ $chr(9) $+ + 0 Option/Protection $+ $chr(9) $+ 0 Description
  did -i $dname 4 1 seticon normal $icon(true.ico)
  did -i $dname 4 1 seticon normal $icon(false.ico)

  var %x = 1
  while (%x <= $chan(0)) {
    did -a $dname 15 $chan(%x)
    inc %x
  }

  coptions.update
}

on *:dialog:coptions:sclick:1: { 
  coptions.update
}

on *:dialog:coptions:sclick:4: { 
  var %type = $$remove($gettok($gettok($did(4,1).seltext,2,9),5-,32),$chr(32))
  if (%type == TopicLock) || (%type == ModeLock) {
    did -e $dname 7
  }
  else did -b $dname 7
}

on *:dialog:coptions:sclick:7: {
  var %type = $$remove($gettok($gettok($did(4,1).seltext,2,9),5-,32),$chr(32))
  if (%type == TopicLock) {
    writeini $settings(chanoptions.txt) $$did(1) LockedTopic $$input(What Topic Do You Want To Keep,e,Topic Lock,$readini($settings(chanoptions.txt),$$did(1),LockedTopic))
  }
  if (%type == ModeLock) {
    writeini $settings(chanoptions.txt) $$did(1) LockedModes $$input(What Modes Do You Want To Keep,e,Topic Lock,$readini($settings(chanoptions.txt),$$did(1),LockedModes))
  }
}

on *:dialog:coptions:sclick:9: {
  writeini $settings(chanoptions.txt) $$did(1) $$remove($gettok($gettok($did(4,1).seltext,2,9),5-,32),$chr(32)) $true
  coptions.update
}

on *:dialog:coptions:sclick:10: {
  writeini $settings(chanoptions.txt) $$did(1) $$remove($gettok($gettok($did(4,1).seltext,2,9),5-,32),$chr(32)) $false
  coptions.update
}

on *:dialog:coptions:sclick:8: {
  if ($dialog(coptions).w < 330) {
    dialog -s coptions -1 -1 611 307
    .splay zip.wav
  }
  elseif ($dialog(coptions).w > 330) {
    dialog -s coptions -1 -1 310 307
  }
}

on *:dialog:coptions:sclick:14: {
  remini $settings(chanoptions.txt) $$did(13).seltext
  did -r $dname 1,13
  var %x = 1, %y = blah
  while (%x <= $ini($settings(chanoptions.txt),0)) {
    did -a $dname 1 $ini($settings(chanoptions.txt),%x)
    if ($ini($settings(chanoptions.txt),%x) != Default) did -a $dname 13 $ini($settings(chanoptions.txt),%x)
    if ($active == $ini($settings(chanoptions.txt),%x)) { var %y = %x }
    inc %x
  }
}

on *:dialog:coptions:sclick:11: {
  writeini $settings(chanoptions.txt) $$did(15) Default $false
  did -r $dname 1,13
  var %x = 1, %y = blah
  while (%x <= $ini($settings(chanoptions.txt),0)) {
    did -a $dname 1 $ini($settings(chanoptions.txt),%x)
    if ($ini($settings(chanoptions.txt),%x) != Default) did -a $dname 13 $ini($settings(chanoptions.txt),%x)
    if ($active == $ini($settings(chanoptions.txt),%x)) { var %y = %x }
    inc %x
  }
}

on *:dialog:coptions:sclick:5: {
  .splay zip.wav
}

on *:dialog:coptions:sclick:6: {
  .splay zip.wav
}

alias coptions.update {
  did -o coptions 4 2 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),PornNick) == $true,1 On,2 Off) $+ $chr(9) $+ Porn Nick $+ $chr(9) $+ + Kick For Porn Style Nicks
  did -o coptions 4 3 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),AsciiNick) == $true,1 On,2 Off) $+ $chr(9) $+ Ascii Nick $+ $chr(9) $+ + Kick For Nicks With Ascii
  did -o coptions 4 4 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),BanProtection) == $true,1 On,2 Off) $+ $chr(9) $+ Ban Protection $+ $chr(9) $+ + Kick If Someone Adds Deny On You
  did -o coptions 4 5 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),AccessAll) == $true,1 On,2 Off) $+ $chr(9) $+ Access All $+ $chr(9) $+ + Kick If Someone Adds *!*@*$* To Access
  did -o coptions 4 6 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),TextFlood) == $true,1 On,2 Off) $+ $chr(9) $+ Text Flood $+ $chr(9) $+ + Kick For Text Floods
  did -o coptions 4 7 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),AwayFlood) == $true,1 On,2 Off) $+ $chr(9) $+ Away Flood $+ $chr(9) $+ + Kick For Away Floods
  did -o coptions 4 8 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),NoColours) == $true,1 On,2 Off) $+ $chr(9) $+ No Colours $+ $chr(9) $+ + Kick For Mirc Colours
  did -o coptions 4 9 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),AutoVoice) == $true,1 On,2 Off) $+ $chr(9) $+ Auto Voice $+ $chr(9) $+ + Give People Voice On Entry
  did -o coptions 4 10 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),AutoHost) == $true,1 On,2 Off) $+ $chr(9) $+ Auto Host $+ $chr(9) $+ + Give People Host On Entry
  did -o coptions 4 11 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),SafeHost) == $true,1 On,2 Off) $+ $chr(9) $+ Safe Host $+ $chr(9) $+ + Hosts Cant Kick Or Dehost Other Hosts Or Host Others
  did -o coptions 4 12 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),NoAwayHost) == $true,1 On,2 Off) $+ $chr(9) $+ No Away Host $+ $chr(9) $+ + Takes Host Of People Who Go Away
  did -o coptions 4 13 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),LoadsHosts) == $true,1 On,2 Off) $+ $chr(9) $+ Loads Hosts $+ $chr(9) $+ + DeHost If Theres Lots Of Hosts
  did -o coptions 4 14 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),LimitOwners) == $true,1 On,2 Off) $+ $chr(9) $+ Limit Owners $+ $chr(9) $+ + Limit The Amount Of Owners There Are
  did -o coptions 4 15 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),LimitHosts) == $true,1 On,2 Off) $+ $chr(9) $+ Limit Hosts $+ $chr(9) $+ + Limit The Amount Of Hosts There Are
  did -o coptions 4 16 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),NoGuestOps) == $true,1 On,2 Off) $+ $chr(9) $+ No Guest Ops $+ $chr(9) $+ + Guests Cant Become Hosts
  did -o coptions 4 17 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),ModeLock) == $true,1 On,2 Off) $+ $chr(9) $+ Mode Lock $+ $chr(9) $+ + If A Host Changes Modes It Resets To Desired Modes
  did -o coptions 4 18 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),TopicLock) == $true,1 On,2 Off) $+ $chr(9) $+ Topic Lock $+ $chr(9) $+ + If A Host Changes Topic It Resets And Kicks
  did -o coptions 4 19 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),NoRgk) == $true,1 On,2 Off) $+ $chr(9) $+ No Rgk $+ $chr(9) $+ + Kicks Random Gatekeepers
  did -o coptions 4 20 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),JoinFlood) == $true,1 On,2 Off) $+ $chr(9) $+ Join Flood $+ $chr(9) $+ + Changes Roomlimit To Stop Guest Floods
  did -o coptions 4 21 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),RoomSpam) == $true,1 On,2 Off) $+ $chr(9) $+ Room Spam $+ $chr(9) $+ + Stops People Posting Room Links
  did -o coptions 4 22 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),CapsKick) == $true,1 On,2 Off) $+ $chr(9) $+ Caps Kick $+ $chr(9) $+ + Kicks For Excessive Caps %70 Caps
  did -o coptions 4 23 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),GoldLock) == $true,1 On,2 Off) $+ $chr(9) $+ Gold Lock $+ $chr(9) $+ + It Locks Gold Host
  did -o coptions 4 24 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),GuestKick) == $true,1 On,2 Off) $+ $chr(9) $+ Guest Kick $+ $chr(9) $+ + It Kicks All Guests
  did -o coptions 4 25 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),DeOwner) == $true,1 On,2 Off) $+ $chr(9) $+ De Owner $+ $chr(9) $+ + It Kicks Anyone Who Deowners You
  did -o coptions 4 26 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),RevengeKick) == $true,1 On,2 Off) $+ $chr(9) $+ Revenge Kick $+ $chr(9) $+ + It Kicks Anyone Who Kicks You
  did -o coptions 4 27 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),IrcCop) == $true,1 On,2 Off) $+ $chr(9) $+ IRC Cop $+ $chr(9) $+ + It Alerts You If Buzzen Staff Enters
  did -o coptions 4 28 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),DeHost) == $true,1 On,2 Off) $+ $chr(9) $+ De Host $+ $chr(9) $+ + It Kicks And Bans Those Who Dehost You
  did -o coptions 4 29 0 + $iif($readini($settings(chanoptions.txt),$did(coptions,1),DeOwner) == $true,1 On,2 Off) $+ $chr(9) $+ IRC Cop $+ $chr(9) $+ + It Kicks And Bans Those Who Deowners You
}
