alias _vr {
  if ($exists(settings/setting.ini) == $false) { write -c settings/setting.ini }
  return $readini settings/setting.ini $$1 $$2 
}
alias _vw {
  if ($exists(settings/setting.ini) == $false) { write -c settings/setting.ini }
  writeini settings/setting.ini $$1 $$2 $$3-
}
alias _vrem {
  if ($exists(settings/setting.ini) == $false) { write -c settings/setting.ini }
  remini settings/setting.ini $$1 $$2 
}
alias -l sqo { 
  if ($_vr(querycon,switch) == on) { return [x] }
  else { return  }
}
alias -l sqf { 
  if ($_vr(querycon,switch) == off) { return [x] }
  else { return }
}
alias secure.query {
  if ($dialog(querycon) == $null) { dialog -m querycon querycon } 
}
alias secure.query.nick {
  dialog -m $_vr(querycon,query.nick) querycon1
  _vrem querycon lastmsg
}
dialog querycon1 {
  title "Secure Query"
  size -1 -1 161 81
  option dbu
  icon images\Icon1.ico, 0
  box "", 33, 3 14 155 42
  button "Accept", 28, 6 63 26 12, disable default ok
  button "Ignore", 26, 34 63 26 12, disable
  button "Decline", 27, 62 63 26 12, disable
  edit "", 1, 32 21 119 10, read autohs
  edit "", 30, 32 31 119 10, read autohs
  edit "", 29, 32 41 119 10, read autohs
  check "Enable Secure Query", 31, 10 6 70 7
  button "Setup", 2, 96 63 22 12
  button "Add access", 3, 120 63 35 12, disable
  box "", 4, 3 57 88 22
  text "Nick :", 5, 7 22 15 8
  text "Address :", 6, 7 32 23 8
  text "Message :", 7, 7 42 25 8
  text "", 8, 130 5 27 8, right
  text "", 9, 76 5 53 8, right
  box "", 10, 93 57 65 22
}
dialog querycon {
  title "Secure Query [/secure.query]"
  size -1 -1 192 153
  option dbu
  icon images\Icon1.ico, 0
  button "OK", 12, 142 139 46 12, default ok
  tab "Config", 2, 3 1 186 135
  edit "", 3, 11 55 171 10, tab 2 autohs
  text "Standby message:", 13, 11 47 47 7, tab 2
  edit "", 4, 11 76 171 10, tab 2 autohs
  check "Enable", 15, 16 106 32 10, tab 2
  button "Select sound", 16, 54 105 37 11, tab 2
  box "Audible alert on query request:", 17, 11 89 86 38, tab 2
  edit "", 208, 105 99 19 10, tab 2
  button "-", 206, 145 99 15 10, tab 2
  text "Secs", 210, 126 101 14 7, tab 2
  box "Auto-close dialog:", 209, 101 89 81 38, tab 2
  button "+", 207, 162 99 15 10, tab 2
  text "Decline message:", 14, 11 68 47 7, tab 2
  check "Enable Secure Query", 33, 16 29 66 10, tab 2
  check "Notify user has access", 49, 102 29 66 10, tab 2
  check "Enable auto-close", 50, 106 112 58 10, tab 2
  box "", 51, 11 22 171 21, tab 2
  tab "Log", 11
  list 34, 11 24 64 72, tab 11 sort size hsbar
  button "Remove", 35, 11 99 31 12, tab 11
  button "Copy", 39, 142 99 39 12, tab 11
  check "Log query requests", 43, 12 118 58 10, tab 11
  edit "", 52, 113 117 68 10, tab 11 autohs
  button "Add access", 53, 76 116 35 12, tab 11
  edit "", 64, 77 24 105 72, tab 11 read multi vsbar
  button "Remove All", 65, 44 99 31 12, tab 11
  tab "Access", 40
  list 41, 11 51 171 62, tab 40 sort size hsbar
  button "Remove", 42, 144 116 37 12, disable tab 40
  text "User access:", 44, 11 42 32 8, tab 40
  edit "", 45, 34 27 115 10, tab 40 autohs
  button "Add", 46, 152 26 30 12, disable tab 40
  text "Address:", 47, 11 28 21 8, tab 40
  box "", 1, 7 17 179 115
}

on *:dialog:*:init:*:{ 
  if ($dialog(querycon) == $dname) {
    if ($_vr(querycon,switch) == on) { did -c querycon 33 } 
    elseif ($_vr(querycon,switch) == $null) { _vw querycon switch on | did -c querycon 33 }
    if ($_vr(querycon,ignore.host) == $null) { _vw querycon ignore.host on | _vw querycon ignore.uni off }
    if ($_vr(querycon,decline) == $null) { _vw querycon decline Sorry, I have declined your query, please try a more convient time. }
    did -o querycon 3 1 $_vr(querycon,standby)
    did -o querycon 4 1 $_vr(querycon,decline)
    if ($_vr(querycon,soundswitch) == on) { did -c querycon 15 }
    if ($_vr(querycon,timer) == $null) { _vw querycon timer 240 }
    did -o querycon 208 1 $_vr(querycon,timer) 
    if ($_vr(querycon,log) == on) { did -c querycon 43 }
    elseif ($_vr(querycon,log) == $null) { _vw querycon log on | did -c querycon 43 }
    if ($_vr(querycon,notifyaccess) == on) { did -c querycon 49 }
    elseif ($_vr(querycon,notifyaccess) == $null) { _vw querycon notifyaccess on | did -c querycon 49 }
    if ($_vr(querycon,auto-close) == on) { did -c querycon 50 }
    did -b querycon 46,42 
    nick.list 
    s.levels
    did -z querycon 34
  }
  if ($dialog($dname) == $_vr(querycon,query.nick)) { 
    if ($_vr(querycon,auto-close) == on) { %qs.nick = $_vr(querycon,query.nick) | .timer 1 $sq_t close.qw }
  }
}
on *:dialog:querycon:edit:*:{ 
  if ($did == 3) { 
    if ($did(querycon,3).text != $null) {    
      _vw querycon standby $did(querycon,3).text 
    }
  }
  if ($did == 4) { 
    if ($did(querycon,4).text != $null) {    
      _vw querycon decline $did(querycon,4).text 
    }
  }
  if ($did == 45) { 
    if ($did(querycon,45).text != $null) { did -e querycon 46 }
    elseif ($did(querycon,45).text == $null) { did -b querycon 46 }
  }
  if ($did == 208) { 
    if ($did(querycon,208).text != $null) {    
      _vw querycon timer $did(querycon,208).text 
    }
  }
  if ($did == 214) { 
    if ($did(querycon,214).text != $null) {  
      _vw querycon max.query $did(querycon,214).text 
    }  
  }
  if ($did == 217) { 
    if ($did(querycon,217).text != $null) {  
      _vw querycon max.query.sec $did(querycon,217).text 
    }
  }
}

on *:dialog:*:sclick:*:{ 
  if (Query request $dname == $dialog($dname).title) { 
    if ($did == 2) { secure.query }   
    if ($did == 3) {
      auser -a securequery $address($did(1,$did(1)),3) $did(1,$did(1)) | did -b $did(1,$did(1)) 3 
      if ($_vr(querycon,notifyaccess) == on) { if ($server != $null) { .msg $did(1,$did(1)) (Secure Query) Now you have free access to message me } }
    }   
    if ($did == 27) { .ignore -pu180 $did(30,$did(30)) | .msg $did(1,$did(1)) (Secure Query) $_vr(querycon,decline) |  dialog -x $did(1,$did(1)) }
    if ($did == 28) {  
      .ignore -r $address($did(1,$did(1)),2) | query $did(1,$did(1)) | .timer -m 1 1 echo $did(1,$did(1)) < $+ $did(1,$did(1)) $+ > $did(29,$did(29)) |  _vrem querycon lastmsg 
      if ($server != $null) { .msg $did(1,$did(1)) (Secure Query) Query request accepted }
      dialog -x $did(1,$did(1))
    }
    if ($did == 26) { .ignore -p $address($did(1,$did(1)),3) | dialog -x $did(1,$did(1)) }
    if ($did == 31) {
      if ($_vr(querycon,switch) != on) { _vw querycon switch on | set %sq.was on }
      else { _vw querycon switch off | set %sq.was off }
    }
  }
  if ($dialog(querycon) ==  $dname) { 
    if ($did == 15) { 
      if ($_vr(querycon,soundswitch) != on) {  _vw querycon soundswitch on | did -c querycon 15 }
      else { _vw querycon soundswitch off | did -u querycon 15 }
    }
    if ($did == 16) { setquerysound }
    if ($did == 206) { if (%timer > 0) { dec %timer 1 | did -o querycon 208 1 %timer | _vw querycon timer %timer } }
    if ($did == 207) { inc %timer 1 | did -o querycon 208 1 %timer | _vw querycon timer %timer }

    if ($did == 39) { clipboard < $+ $did(34,$did(34).sel) $+ > $sr($did(34,$did(34).sel),msg) }
    if ($did == 34) { did -r querycon 64 | did -a querycon 64 $chr(91) $+ $sr($did(34,$did(34).sel),date) $+ $chr(93) | did -a querycon 64 $crlf $sr($did(34,$did(34).sel),msg) | did -o querycon 52 1 $_vr(securequery,$did(34,$did(34).sel))) }
    if ($did == 33) {
      if ($_vr(querycon,switch) != on) { _vw querycon switch on | set %sq.was on }
      else { _vw querycon switch off | set %sq.was off }
    }
    if ($did == 35) { write -ds $+ $did(34,$did(34).sel) system/protections/securequery/names.txt | _vrem securequery $did(34,$did(34).sel)) | .timer -m 1 1 nick.list }
    if ($did == 41) { did -e querycon 42,46 | did -o querycon 45 1 $did(41,$did(41).sel)) }
    if ($did == 42) { ruser $did(41,$did(41).sel) | s.levels }
    if ($did == 43) { 
      if ($_vr(querycon,log) != on) { _vw querycon log on | did -c querycon 43 }
      else { _vw querycon log off }
    }  
    if ($did == 50) { 
      if ($_vr(querycon,auto-close) != on) { _vw querycon auto-close on | did -c querycon 50 }
      else { _vw querycon auto-close off }
    }
    if ($did == 53) { 
      if ($did(querycon,52).text != $null) {    
        .auser -a  securequery $did(querycon,52).text | did -r querycon 52 
      }
    }
    if ($did == 49) { 
      if ($_vr(querycon,notifyaccess) != on) { _vw querycon notifyaccess on | did -c querycon 49 }
      else { _vw querycon notifyaccess off }
    }
    if ($did == 46) { 
      if ($did(querycon,45).text != $null) {    
        .auser -a  securequery $did(querycon,45).text | did -r querycon 45 | s.levels
      }
    }
    if ($did == 65) { .remove settings/names.txt | .remove settings/logs.ini | did -r querycon 64,34,52 }    
    if ($did == 211) {
      if ($_vr(querycon,ignore.uni) == off) { _vw querycon ignore.uni on | _vw querycon ignore.host off | did -c querycon 211 | did -u querycon 212 }
      else { _vw querycon ignore.uni off | _vw querycon ignore.host on | did -u querycon 211 | did -c querycon 212 }
    }
    if ($did == 212) {
      if ($_vr(querycon,ignore.host) == off) { _vw querycon ignore.host on | _vw querycon ignore.uni off | did -c querycon 212 | did -u querycon 211 }
      else { _vw querycon ignore.host off | _vw querycon ignore.uni on | did -u querycon 212 | did -c querycon 211 }
    }
    if ($did == 219) {
      if ($_vr(querycon,netflood) == off) { _vw querycon netflood on | did -c querycon 219 | did -e querycon 211,217,212,214 }
      else { _vw querycon netflood off | did -u querycon 219 | did -b querycon 211,217,212,214 }
    }
  }
}
alias -l sr {
  if ($exists(settings/logs.ini) == $false) { write -c settings/logs.ini }
  return $readini settings/logs.ini $$1 $$2 
}
alias -l sw {
  if ($exists(settings/logs.ini) == $false) { write -c settings/logs.ini }
  writeini settings/logs.ini $$1 $$2 $$3-
}
alias -l srem {
  if ($exists(settings/logs.ini) == $false) { write -c  settings/logs.ini }
  remini settings/logs.ini $$1 $$2 
}
on ^*:open:?: {
  if ($_vr(querycon,switch) == $null) { _vw querycon switch on | set %sq.was on }
  if ($finddir(scripts,securequery*,1) == $null) { mkdir scripts/securequery }
  if ($_vr(querycon,netflood) != on) {
    inc %upflood15 1  
    if (%upflood15 > $_vr(querycon,max.query)) { 
      if ($_vr(querycon,ignore.uni) == on) { .ignore -pu $+ $_vr(querycon,max.query.sec) *!*@* }
      else { .ignore -pu $+ $_vr(querycon,max.query.sec) $wildsite }
      echo -a ::: Query floods detected from $nick $+  ( $+ $wildsite $+ ) now ignored for $_vr(querycon,max.query.sec) secs.
    } 
    .timer 1 60 unset %upflood15     
  }
  if ($_vr(querycon,standby) == $null) { _vw querycon standby Please standby for acknowledgement. You will be notified if accepted, and until then your msgs will be ignored. }
  if ($level($address($nick,3)) == securequery) { goto end }
  if ($network = DALnet) && ($nick == Global) { goto end } 
  if ($network = DALnet) && ($nick == Nickserv) { goto end } 
  if ($network = DALnet) && ($nick == Chanserv) { goto end } 
  if ($network = DALnet) && ($nick == Memoserv) { goto end }
  if ($network = DALnet) && ($nick == Operserv) { goto end }
  if ($network = DALnet) && ($nick == Statserv) { goto end } 
  if ($_vr(querycon,switch) == on) {
    if ($_vr(querycon,soundswitch) == on) { if ($_vr(querycon,sound) != $null) { .splay $_vr(querycon,sound) } }
    echo -a ::: Query with $nick ( $+ $address $+ ) on $network
    if ($_vr(querycon,log) == on) { 
      if ($read(settings/names.txt, w, $nick) == $nick) { write -ds $+ $nick settings/names.txt }
      sw $nick date $asctime(h:nn:sstt m/d) | sw $nick msg $strip($1-,burc) | write settings/names.txt $nick | nick.list
    }
    .msg $nick (Secure Query) $_vr(querycon,standby)
    _vw  querycon query.nick $nick
    if ($dialog($nick) == $null) { secure.query.nick }
    dialog -t $_vr(querycon,query.nick) Query request $nick
    did -o $nick 1 1 $_vr(querycon,query.nick)
    .ignore -pu120 $wildsite    
    whosqial $nick  
    did -o $nick 9 1 ( $+ $network $+ )  
    did -o $nick 30 1 Updating... 
    did -o $nick 29 1 $strip($1-,burc)
    did -o $nick 8 1 $asctime(hh:nntt)

    if ($_vr(querycon,switch) == on) { did -c $nick 31 }
    haltdef
    :end 
  }  
}
#sqialud off
raw 352:*: {
  if ($dialog($6) != $null) { did -o $6 30 1 *!* $+ $3 $+ @ $+ $4  | did -e $6 26,28,3,27 | .timer 1 5 .disable #sqialud | haltdef }
  else { if ($dialog($6) != $null) { did -e $6 26,28,3,27 | .timer 1 5 .disable #sqialud | halt } }
  halt
}
raw 315:*: {
  halt
} 
#sqialud end
alias -l whosqial { .enable #sqialud | .who $$1 } 
alias -l secure.dir {
  mkdir  " $+ scripts $+ / $+ " 
  return scripts $+ /
}
alias -l sq_t { 
  return $_vr(querycon,timer) 
}

alias -l nick.list {
  if ($dialog(querycon) != $null) { 
    did -r querycon 64,34,52 
    var %fst = $lines(settings/names.txt)   
    var %f = 1
    while (%f <= %fst) { did -a querycon 34 $read(settings/names.txt,%f) | inc %f 1 }
  }
}
alias -l s.levels {
  did -r querycon 41
  var %s.l = $ulist(*,securequery,0)
  if (%s.l == 0) { did -b querycon 42 | return }
  else  did -e querycon 42
  var %s.w = 0
  :loop
  inc %s.w
  if (%s.w <= %s.l) { did -a querycon 41  $ulist(*,securequery,%s.w) | goto loop }
  else return
}
alias -l close.qw { if ($dialog(%qs.nick) != $null) dialog -x %qs.nick }
alias -l setquerysound {
  _vw querycon sound $$dir="Choose a wav:" $mircdir*.wav;*mp3;*.mid 
}
